UG NX二次开发 创建子进程以处理装配体中的所有零部件 C#

1、简介

有时候,我们需要处理给定装配体中的所有零件。本教程中以递归方式逐步完成装配体结构,允许处理每个零件。如果代码按照提供的方式运行,它将打开一个信息窗口,并打印每个零部件的名称和当前活动排列(如果是子装配体)。代码可在操作记录中直接运行(NX9.0测试)。

2、代码

using System;
using NXOpen;
using NXOpen.UF;
using NXOpen.Assemblies;

sealed class NXJournal
{
    public static Session theSession = Session.GetSession();
    public static UFSession ufs = UFSession.GetUFSession();
    public static ListingWindow lw = theSession.ListingWindow;

    public static void Main()
    {
        Part workPart = theSession.Parts.Work;
        Part dispPart = theSession.Parts.Display;
        lw.Open();
        try
        {
            ComponentAssembly c = dispPart.ComponentAssembly;//返回装配体的组件集
            //若处理工作部分而非显示部分,注释上一行,取消注释下一行
            //ComponentAssembly c = workPart.ComponentAssembly

            if (c.RootComponent != null  )
            {
                //插入代码以处理“根组件”(装配文件) (assembly file)
                lw.WriteLine("Assembly: " + c.RootComponent.DisplayName);
                lw.WriteLine(c.RootComponent.GetChildren().Length + " components");
                lw.WriteLine(" + Active Arrangement: " + c.ActiveArrangement.Name);

                reportComponentChildren(c.RootComponent, 0);
            }
            else
            {
                lw.WriteLine("Part has no components");
            }
        }
        catch (Exception e)
        {
            theSession.ListingWindow.WriteLine("Failed: " + e.ToString());
        }
        lw.Close();

    }
    public static void reportComponentChildren(Component comp, int indent)
    {
        foreach (Component child in comp.GetChildren())
        {
            //插入代码以处理零部件或子部件
            lw.WriteLine("");
            lw.WriteLine(new string(' ', indent * 2) + child.DisplayName);
            lw.WriteLine("child.Tag: " + child.Tag.ToString());
 
            if (child.GetChildren().Length != 0)

            {
                //这是一个子部件,请添加特定于部件的代码
                lw.WriteLine(new string(' ', indent * 2) + child.GetChildren().Length + " components");
                lw.WriteLine(new string(' ', indent * 2) + " + Active Arrangement: " + child.OwningPart.ComponentAssembly.ActiveArrangement.Name);  
            }
            else
            {
               
            }
            reportComponentChildren(child, indent + 1);
        }
    }
    public static int GetUnloadOption(string arg)
    {
        return System.Convert.ToInt32(Session.LibraryUnloadOption.Immediately);
    }

}

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

UG NXOpen学徒

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值